libzypp 17.37.10

zyppng::BasicState< StatemachineType, isFin > Class Template Reference

`#include <zypp-core/zyppng/base/statemachine.h>`

Inheritance diagram for zyppng::BasicState< StatemachineType, isFin >:

## Public Member Functions
| BasicState (StatemachineType &sm)
| ~BasicState () override
| BasicState (BasicState &&) noexcept=default
BasicState & | operator= (BasicState &&) noexcept=default
StatemachineType & | stateMachine ()
const StatemachineType & | stateMachine () const
Public Member Functions inherited from zyppng::Base
| Base ()
virtual | ~Base ()
WeakPtr | parent () const
void | addChild (const Base::Ptr &child)
void | removeChild (const Ptr &child)
const std::unordered_set< Ptr > & | children () const
std::thread::id | threadId () const
template<typename T>
std::vector< std::weak_ptr< T > > | findChildren () const
template<typename T>
std::shared_ptr< T > | shared_this () const
template<typename T>
std::shared_ptr< T > | shared_this ()
template<typename T>
std::weak_ptr< T > | weak_this () const
template<typename T>
std::weak_ptr< T > | weak_this ()
template<typename SenderFunc, typename ReceiverFunc>
auto | connect (SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
std::enable_if_t< std::is_member_function_pointer_v< SenderFunc >, connection > | connectFunc (SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)

## Static Public Attributes
static constexpr bool | isFinal = isFin

## Private Attributes
StatemachineType & | _sm

## Additional Inherited Members
Public Types inherited from zyppng::Base
using | Ptr = std::shared_ptr<Base>
using | WeakPtr = std::weak_ptr<Base>
Static Public Member Functions inherited from zyppng::Base
template<typename Obj, typename Functor>
static decltype(auto) | make_base_slot (Obj *o, Functor &&f)
template<typename SenderFunc, typename ReceiverFunc>
static auto | connect (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
static auto | connectFunc (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
Protected Member Functions inherited from zyppng::Base
| Base (BasePrivate &dd)
Protected Attributes inherited from zyppng::Base
std::unique_ptr< BasePrivate > | d_ptr

## Detailed Description

template<typename StatemachineType, bool isFin>
class zyppng::BasicState< StatemachineType, isFin >

Implements the most basic parts of a State, the functions enter() and exit() still need to be implemented in the base class

Definition at line 570 of file statemachine.h.

## Constructor & Destructor Documentation

## ◆ BasicState() [1/2]

template<typename StatemachineType, bool isFin>

zyppng::BasicState< StatemachineType, isFin >::BasicState | ( | StatemachineType & | sm | ) |
| inline

Definition at line 575 of file statemachine.h.

## ◆ ~BasicState()

template<typename StatemachineType, bool isFin>

zyppng::BasicState< StatemachineType, isFin >::~BasicState | ( |  | ) |
| inline override

Definition at line 576 of file statemachine.h.

## ◆ BasicState() [2/2]

template<typename StatemachineType, bool isFin>

zyppng::BasicState< StatemachineType, isFin >::BasicState | ( | BasicState< StatemachineType, isFin > && |  | ) |
| default noexcept

## Member Function Documentation

## ◆ operator=()

template<typename StatemachineType, bool isFin>

BasicState & zyppng::BasicState< StatemachineType, isFin >::operator= | ( | BasicState< StatemachineType, isFin > && |  | ) |
| default noexcept

## ◆ stateMachine() [1/2]

template<typename StatemachineType, bool isFin>

StatemachineType & zyppng::BasicState< StatemachineType, isFin >::stateMachine | ( |  | ) |
| inline

Definition at line 581 of file statemachine.h.

## ◆ stateMachine() [2/2]

template<typename StatemachineType, bool isFin>

const StatemachineType & zyppng::BasicState< StatemachineType, isFin >::stateMachine | ( |  | ) | const
| inline

Definition at line 585 of file statemachine.h.

## Member Data Documentation

## ◆ isFinal

template<typename StatemachineType, bool isFin>

bool zyppng::BasicState< StatemachineType, isFin >::isFinal = isFin
| static constexpr

Definition at line 573 of file statemachine.h.

## ◆ _sm

template<typename StatemachineType, bool isFin>

StatemachineType& zyppng::BasicState< StatemachineType, isFin >::_sm
| private

Definition at line 590 of file statemachine.h.

The documentation for this class was generated from the following file:

- zypp-core/zyppng/base/statemachine.h